/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: DTULTATU_SERIENFTP                                                   */
/* Criao:                                                                   */
/* 05/04/2011 - Kessiler Almeida S. Rodrigues                                 */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SERIENFTP'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_SERIENFTP
  GO

CREATE TRIGGER DTULTATU_SERIENFTP
ON SERIENFTP
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERIENFTP', 'CDEMPRESA='+CDEMPRESA+';CDINSCMUNI='+CDINSCMUNI+
                                    ';CDINSCESTA='+CDINSCESTA+';CDSERIE='+CDSERIE+
                                    ';CDTIPOOPER='+CDTIPOOPER+';IDENTRSAIDOP='+IDENTRSAIDOP+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERIENFTP
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE ISNULL(SERIENFTP.CDEMPRESA,   0) = ISNULL(INSERTED.CDEMPRESA,   0)
        AND ISNULL(SERIENFTP.CDINSCMUNI,  0) = ISNULL(INSERTED.CDINSCMUNI,  0)
        AND ISNULL(SERIENFTP.CDINSCESTA,  0) = ISNULL(INSERTED.CDINSCESTA,  0)
        AND ISNULL(SERIENFTP.CDSERIE,     0) = ISNULL(INSERTED.CDSERIE,     0)
        AND ISNULL(SERIENFTP.CDTIPOOPER,  0) = ISNULL(INSERTED.CDTIPOOPER,  0)
        AND ISNULL(SERIENFTP.IDENTRSAIDOP,0) = ISNULL(INSERTED.IDENTRSAIDOP,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_SERIENFTP','5.20.xxx';
GO